RadioLib Universal wireless communication library for Arduino

Public Member Functions | List of all members
Si443x Class Reference

Base class for Si443x series. All derived classes for Si443x (e.g. Si4431 or Si4432) inherit from this base class. This class should not be instantiated directly from Arduino sketch, only from its derived classes. More...

`#include <Si443x.h>`

Inheritance diagram for Si443x:

## Public Member Functions
| Si443x (Module *mod)
| Default constructor. More...
int16_t | begin (float br, float freqDev, float rxBw, uint8_t preambleLen)
| Initialization method. More...
void | reset ()
| Reset method. Will reset the chip to the default state using SDN pin.
int16_t | transmit (uint8_t *data, size_t len, uint8_t addr=0) override
| Binary transmit method. Will transmit arbitrary binary data up to 64 bytes long. For overloads to transmit Arduino String or C-string, see PhysicalLayer::transmit. More...
int16_t | receive (uint8_t *data, size_t len) override
| Binary receive method. Will attempt to receive arbitrary binary data up to 64 bytes long. For overloads to receive Arduino String, see PhysicalLayer::receive. More...
int16_t | sleep ()
| Sets the module to sleep to save power. Module will not be able to transmit or receive any data while in sleep mode. Module will wake up automatically when methods like transmit or receive are called. More...
int16_t | standby () override
| Sets the module to standby (with XTAL on). More...
int16_t | standby (uint8_t mode) override
| Sets the module to standby. More...
int16_t | transmitDirect (uint32_t frf=0) override
| Enables direct transmission mode. While in direct mode, the module will not be able to transmit or receive packets. More...
int16_t | receiveDirect () override
| Enables direct reception mode. While in direct mode, the module will not be able to transmit or receive packets. More...
int16_t | packetMode ()
| Disables direct mode and enables packet mode, allowing the module to receive packets. More...
void | setIrqAction (void(*func)(void))
| Sets interrupt service routine to call when IRQ activates. More...
void | clearIrqAction ()
| Clears interrupt service routine to call when IRQ activates.
void | setPacketReceivedAction (void(*func)(void))
| Sets interrupt service routine to call when a packet is received. More...
void | clearPacketReceivedAction ()
| Clears interrupt service routine to call when a packet is received.
void | setPacketSentAction (void(*func)(void))
| Sets interrupt service routine to call when a packet is sent. More...
void | clearPacketSentAction ()
| Clears interrupt service routine to call when a packet is sent.
int16_t | startTransmit (uint8_t *data, size_t len, uint8_t addr=0) override
| Interrupt-driven binary transmit method. Will start transmitting arbitrary binary data up to 64 bytes long. More...
int16_t | finishTransmit () override
| Clean up after transmission is done. More...
int16_t | startReceive ()
| Interrupt-driven receive method. IRQ will be activated when full valid packet is received. More...
int16_t | startReceive (uint32_t timeout, uint16_t irqFlags, uint16_t irqMask, size_t len)
| Interrupt-driven receive method, implemented for compatibility with PhysicalLayer. More...
int16_t | readData (uint8_t *data, size_t len) override
| Reads data that was received after calling startReceive method. When the packet length is not known in advance, getPacketLength method must be called BEFORE calling readData! More...
int16_t | setBitRate (float br)
| Sets FSK bit rate. Allowed values range from 0.123 to 256.0 kbps. More...
int16_t | setFrequencyDeviation (float freqDev) override
| Sets FSK frequency deviation from carrier frequency. Allowed values range from 0.625 to 320.0 kHz. More...
int16_t | setRxBandwidth (float rxBw)
| Sets receiver bandwidth. Allowed values range from 2.6 to 620.7 kHz. More...
int16_t | setSyncWord (uint8_t *syncWord, size_t len)
| Sets sync word. Up to 4 bytes can be set as sync word. More...
int16_t | setPreambleLength (uint8_t preambleLen)
| Sets preamble length. More...
size_t | getPacketLength (bool update=true) override
| Query modem for the packet length of received payload. More...
int16_t | setEncoding (uint8_t encoding) override
| Sets transmission encoding. Only available in FSK mode. Allowed values are RADIOLIB_ENCODING_NRZ, RADIOLIB_ENCODING_MANCHESTER and RADIOLIB_ENCODING_WHITENING. More...
int16_t | setDataShaping (uint8_t sh) override
| Sets Gaussian filter bandwidth-time product that will be used for data shaping. Only available in FSK mode with FSK modulation. Allowed values are RADIOLIB_SHAPING_0_5 or RADIOLIB_SHAPING_1_0. Set to RADIOLIB_SHAPING_NONE to disable data shaping. More...
void | setRfSwitchPins (uint32_t rxEn, uint32_t txEn)
| Some modules contain external RF switch controlled by pins. This function gives RadioLib control over those pins to automatically switch between various modes: When idle both pins will be LOW, during TX the `txEn` pin will be HIGH, during RX the `rxPin` will be HIGH. More...
void | setRfSwitchTable (const uint32_t(&pins)[Module::RFSWITCH_MAX_PINS], const Module::RfSwitchMode_t table[])
| Some modules contain external RF switch controlled by pins. This function gives RadioLib control over those pins to automatically switch between various modes. More...
uint8_t | randomByte ()
| Get one truly random byte from RSSI noise. More...
int16_t | getChipVersion ()
| Read version SPI register. Should return RADIOLIB_SI443X_DEVICE_VERSION (0x06) if Si443x is connected and working. More...
void | setDirectAction (void(*func)(void))
| Set interrupt service routine function to call when data bit is received in direct mode. More...
void | readBit (uint32_t pin)
| Function to read and process data bit in direct reception mode. More...
int16_t | fixedPacketLengthMode (uint8_t len=RADIOLIB_SI443X_MAX_PACKET_LENGTH)
| Set modem in fixed packet length mode. More...
int16_t | variablePacketLengthMode (uint8_t maxLen=RADIOLIB_SI443X_MAX_PACKET_LENGTH)
| Set modem in variable packet length mode. More...
int16_t | transmit (const char *str, uint8_t addr=0)
| C-string transmit method. More...
virtual int16_t | transmit (uint8_t *data, size_t len, uint8_t addr=0)
| Binary transmit method. Must be implemented in module class. More...
virtual int16_t | receive (uint8_t *data, size_t len)
| Binary receive method. Must be implemented in module class. More...
int16_t | startTransmit (const char *str, uint8_t addr=0)
| Interrupt-driven Arduino String transmit method. Unlike the standard transmit method, this one is non-blocking. Interrupt pin will be activated when transmission finishes. More...
virtual int16_t | startTransmit (uint8_t *data, size_t len, uint8_t addr=0)
| Interrupt-driven binary transmit method. More...
virtual int16_t | readData (uint8_t *data, size_t len)
| Reads data that was received after calling startReceive method. More...
Public Member Functions inherited from PhysicalLayer
| PhysicalLayer (float step, size_t maxLen)
| Default constructor. More...
int16_t | transmit (const char *str, uint8_t addr=0)
| C-string transmit method. More...
int16_t | startTransmit (const char *str, uint8_t addr=0)
| Interrupt-driven Arduino String transmit method. Unlike the standard transmit method, this one is non-blocking. Interrupt pin will be activated when transmission finishes. More...
virtual int16_t | setFrequency (float freq)
| Sets carrier frequency. Must be implemented in module class. More...
virtual int16_t | invertIQ (bool enable)
| Set IQ inversion. Must be implemented in module class if the module supports it. More...
virtual int16_t | setOutputPower (int8_t power)
| Set output power. Must be implemented in module class if the module supports it. More...
virtual int16_t | setPreambleLength (size_t len)
| Set preamble length. Must be implemented in module class if the module supports it. More...
virtual int16_t | setDataRate (DataRate_t dr)
| Set data. Must be implemented in module class if the module supports it. More...
virtual int16_t | checkDataRate (DataRate_t dr)
| Check the data rate can be configured by this module. Must be implemented in module class if the module supports it. More...
float | getFreqStep () const
| Gets the module frequency step size that was set in constructor. More...
virtual float | getRSSI ()
| Gets RSSI (Recorded Signal Strength Indicator) of the last received packet. More...
virtual float | getSNR ()
| Gets SNR (Signal to Noise Ratio) of the last received packet. Only available for LoRa modem. More...
virtual uint32_t | getTimeOnAir (size_t len)
| Get expected time-on-air for a given size of payload. More...
virtual uint32_t | calculateRxTimeout (uint32_t timeoutUs)
| Calculate the timeout value for this specific module / series (in number of symbols or units of time) More...
virtual int16_t | irqRxDoneRxTimeout (uint16_t &irqFlags, uint16_t &irqMask)
| Create the flags that make up RxDone and RxTimeout used for receiving downlinks. More...
virtual bool | isRxTimeout ()
| Check whether the IRQ bit for RxTimeout is set. More...
virtual int16_t | startChannelScan ()
| Interrupt-driven channel activity detection method. interrupt will be activated when packet is detected. Must be implemented in module class. More...
virtual int16_t | getChannelScanResult ()
| Read the channel scan result. More...
virtual int16_t | scanChannel ()
| Check whether the current communication channel is free or occupied. Performs CAD for LoRa modules, or RSSI measurement for FSK modules. More...
int32_t | random (int32_t max)
| Get truly random number in range 0 - max. More...
int32_t | random (int32_t min, int32_t max)
| Get truly random number in range min - max. More...
int16_t | startDirect ()
| Configure module parameters for direct modes. Must be called prior to "ham" modes like RTTY or AX.25. Only available in FSK mode. More...
int16_t | setDirectSyncWord (uint32_t syncWord, uint8_t len)
| Set sync word to be used to determine start of packet in direct reception mode. More...
int16_t | available ()
| Get the number of direct mode bytes currently available in buffer. More...
void | dropSync ()
| Forcefully drop synchronization.
uint8_t | read (bool drop=true)
| Get data from direct mode buffer. More...
virtual int16_t | setDIOMapping (uint32_t pin, uint32_t value)
| Configure DIO pin mapping to get a given signal on a DIO pin (if available). More...
virtual void | setChannelScanAction (void(*func)(void))
| Sets interrupt service routine to call when a channel scan is finished. More...
virtual void | clearChannelScanAction ()
| Clears interrupt service routine to call when a channel scan is finished.

## Detailed Description

Base class for Si443x series. All derived classes for Si443x (e.g. Si4431 or Si4432) inherit from this base class. This class should not be instantiated directly from Arduino sketch, only from its derived classes.

## Constructor & Destructor Documentation

## ◆ Si443x()

Si443x::Si443x | ( | Module * | mod | ) |

Default constructor.

Parameters

  mod | Instance of Module that will be used to communicate with the radio.

## Member Function Documentation

## ◆ begin()

int16_t Si443x::begin | ( | float | br,
|  | float | freqDev,
|  | float | rxBw,
|  | uint8_t | preambleLen
| ) |  |

Initialization method.

Parameters

  br | Bit rate of the FSK transmission in kbps (kilobits per second).
  freqDev | Frequency deviation of the FSK transmission in kHz.
  rxBw | Receiver bandwidth in kHz.
  preambleLen | Preamble Length in bits.

Returns
  Status Codes

## ◆ finishTransmit()

int16_t Si443x::finishTransmit | ( |  | ) |
| override virtual

Clean up after transmission is done.

Returns
  Status Codes

Reimplemented from PhysicalLayer.

## ◆ fixedPacketLengthMode()

int16_t Si443x::fixedPacketLengthMode | ( | uint8_t | len = `RADIOLIB_SI443X_MAX_PACKET_LENGTH` | ) |

Set modem in fixed packet length mode.

Parameters

  len | Packet length.

Returns
  Status Codes

## ◆ getChipVersion()

int16_t Si443x::getChipVersion | ( |  | ) |

Read version SPI register. Should return RADIOLIB_SI443X_DEVICE_VERSION (0x06) if Si443x is connected and working.

Returns
  Version register contents or Status Codes

## ◆ getPacketLength()

size_t Si443x::getPacketLength | ( | bool | update = `true` | ) |
| override virtual

Query modem for the packet length of received payload.

Parameters

  update | Update received packet length. Will return cached value when set to false.

Returns
  Length of last received packet in bytes.

Reimplemented from PhysicalLayer.

## ◆ packetMode()

int16_t Si443x::packetMode | ( |  | ) |

Disables direct mode and enables packet mode, allowing the module to receive packets.

Returns
  Status Codes

## ◆ randomByte()

uint8_t Si443x::randomByte | ( |  | ) |
| virtual

Get one truly random byte from RSSI noise.

Returns
  TRNG byte.

Reimplemented from PhysicalLayer.

## ◆ readBit()

void Si443x::readBit | ( | uint32_t | pin | ) |
| virtual

Function to read and process data bit in direct reception mode.

Parameters

  pin | Pin on which to read.

Reimplemented from PhysicalLayer.

## ◆ readData() [1/2]

int16_t PhysicalLayer::readData

Reads data that was received after calling startReceive method.

Parameters

  data | Pointer to array to save the received binary data.
  len | Number of bytes that will be read. When set to 0, the packet length will be retrieved automatically. When more bytes than received are requested, only the number of bytes requested will be returned.

Returns
  Status Codes

## ◆ readData() [2/2]

int16_t Si443x::readData | ( | uint8_t * | data,
|  | size_t | len
| ) |  |
| override virtual

Reads data that was received after calling startReceive method. When the packet length is not known in advance, getPacketLength method must be called BEFORE calling readData!

Parameters

  data | Pointer to array to save the received binary data.
  len | Number of bytes that will be read. When set to 0, the packet length will be retrieved automatically. When more bytes than received are requested, only the number of bytes requested will be returned.

Returns
  Status Codes

Reimplemented from PhysicalLayer.

## ◆ receive() [1/2]

int16_t PhysicalLayer::receive

Binary receive method. Must be implemented in module class.

Parameters

  data | Pointer to array to save the received binary data.
  len | Number of bytes that will be received. Must be known in advance for binary transmissions.

Returns
  Status Codes

## ◆ receive() [2/2]

int16_t Si443x::receive | ( | uint8_t * | data,
|  | size_t | len
| ) |  |
| override virtual

Binary receive method. Will attempt to receive arbitrary binary data up to 64 bytes long. For overloads to receive Arduino String, see PhysicalLayer::receive.

Parameters

  data | Pointer to array to save the received binary data.
  len | Number of bytes that will be received. Must be known in advance for binary transmissions.

Returns
  Status Codes

Reimplemented from PhysicalLayer.

## ◆ receiveDirect()

int16_t Si443x::receiveDirect | ( |  | ) |
| override virtual

Enables direct reception mode. While in direct mode, the module will not be able to transmit or receive packets.

Returns
  Status Codes

Reimplemented from PhysicalLayer.

## ◆ setBitRate()

int16_t Si443x::setBitRate | ( | float | br | ) |
| virtual

Sets FSK bit rate. Allowed values range from 0.123 to 256.0 kbps.

Parameters

  br | Bit rate to be set (in kbps).

Returns
  Status Codes

Reimplemented from PhysicalLayer.

## ◆ setDataShaping()

int16_t Si443x::setDataShaping | ( | uint8_t | sh | ) |
| override virtual

Sets Gaussian filter bandwidth-time product that will be used for data shaping. Only available in FSK mode with FSK modulation. Allowed values are RADIOLIB_SHAPING_0_5 or RADIOLIB_SHAPING_1_0. Set to RADIOLIB_SHAPING_NONE to disable data shaping.

Parameters

  sh | Gaussian shaping bandwidth-time product that will be used for data shaping

Returns
  Status Codes

Reimplemented from PhysicalLayer.

## ◆ setDirectAction()

void Si443x::setDirectAction | ( | void(*)(void) | func | ) |
| virtual

Set interrupt service routine function to call when data bit is received in direct mode.

Parameters

  func | Pointer to interrupt service routine.

Reimplemented from PhysicalLayer.

## ◆ setEncoding()

int16_t Si443x::setEncoding | ( | uint8_t | encoding | ) |
| override virtual

Sets transmission encoding. Only available in FSK mode. Allowed values are RADIOLIB_ENCODING_NRZ, RADIOLIB_ENCODING_MANCHESTER and RADIOLIB_ENCODING_WHITENING.

Parameters

  encoding | Encoding to be used.

Returns
  Status Codes

Todo:
  - add inverted Manchester?

Reimplemented from PhysicalLayer.

## ◆ setFrequencyDeviation()

int16_t Si443x::setFrequencyDeviation | ( | float | freqDev | ) |
| override virtual

Sets FSK frequency deviation from carrier frequency. Allowed values range from 0.625 to 320.0 kHz.

Parameters

  freqDev | Frequency deviation to be set (in kHz).

Returns
  Status Codes

Reimplemented from PhysicalLayer.

## ◆ setIrqAction()

void Si443x::setIrqAction | ( | void(*)(void) | func | ) |

Sets interrupt service routine to call when IRQ activates.

Parameters

  func | ISR to call.

## ◆ setPacketReceivedAction()

void Si443x::setPacketReceivedAction | ( | void(*)(void) | func | ) |
| virtual

Sets interrupt service routine to call when a packet is received.

Parameters

  func | ISR to call.

Reimplemented from PhysicalLayer.

## ◆ setPacketSentAction()

void Si443x::setPacketSentAction | ( | void(*)(void) | func | ) |
| virtual

Sets interrupt service routine to call when a packet is sent.

Parameters

  func | ISR to call.

Reimplemented from PhysicalLayer.

## ◆ setPreambleLength()

int16_t Si443x::setPreambleLength | ( | uint8_t | preambleLen | ) |

Sets preamble length.

Parameters

  preambleLen | Preamble length to be set (in bits).

Returns
  Status Codes

## ◆ setRfSwitchPins()

void Si443x::setRfSwitchPins | ( | uint32_t | rxEn,
|  | uint32_t | txEn
| ) |  |

Some modules contain external RF switch controlled by pins. This function gives RadioLib control over those pins to automatically switch between various modes: When idle both pins will be LOW, during TX the `txEn` pin will be HIGH, during RX the `rxPin` will be HIGH.

Radiolib will automatically set the pin mode and value of these pins, so do not control them from the sketch.

When more than two pins or more control over the output values are needed, use the setRfSwitchTable() function.

Parameters

  rxEn | RX enable pin.
  txEn | TX enable pin.

## ◆ setRfSwitchTable()

void Si443x::setRfSwitchTable | ( | const uint32_t(&) | pins[Module::RFSWITCH_MAX_PINS],
|  | const Module::RfSwitchMode_t | table[]
| ) |  |

Some modules contain external RF switch controlled by pins. This function gives RadioLib control over those pins to automatically switch between various modes.

Radiolib will automatically set the pin mode and value of these pins, so do not control them from the sketch.

Parameters

  pins | A reference to an array of pins to control. This should always be an array of 3 elements. If you need less pins, use RADIOLIB_NC for the unused elements.
  table | A reference to an array of pin values to use for each supported mode. Each element is an RfSwitchMode_T struct that lists the mode for which it applies and the values for each of the pins passed in the pins argument respectively.

The `pins` array will be copied into the Module object, so the original array can be deallocated after this call. However, a reference to the `table` array will be stored, so that array must remain valid as long RadioLib is being used.

The `mode` field in each table row should normally use any of the `MODE_*` constants from the Module::OpMode_t enum. However, some radios support additional modes and will define their own OpMode_t enum.

The length of the table is variable (to support radios that add additional modes), so the table must always be terminated with the special END_OF_MODE_TABLE value.

Normally all modes should be listed in the table, but for some radios, modes can be omitted to indicate they are not supported (e.g. when a radio has a high power and low power TX mode but external circuitry only supports low power). If applicable, this is documented in the radio class itself.

#### Example

For example, on a board that has an RF switch with an enable pin connected to PA0 and a TX/RX select pin connected to PA1:

// In global scope, define the pin array and mode table
static const uint32_t rfswitch_pins[] =
{PA0, PA1, RADIOLIB_NC};
static const Module::RfSwitchMode_t rfswitch_table[] = {
{Module::MODE_IDLE, {LOW, LOW}},
{Module::MODE_RX, {HIGH, LOW}},
{Module::MODE_TX, {HIGH, HIGH}},
Module::END_OF_MODE_TABLE,
};
void setup() {
...
// Then somewhere in setup, pass them to radiolib
radio.setRfSwitchTable(rfswitch_pins, rfswitch_table);
...
}
Module::MODE_TX
@ MODE_TX
Transmission mode.
Definition: Module.h:114
Module::MODE_IDLE
@ MODE_IDLE
Idle mode.
Definition: Module.h:108
Module::MODE_RX
@ MODE_RX
Receive mode.
Definition: Module.h:111
Module::RfSwitchMode_t
Description of RF switch pin states for a single mode. See setRfSwitchTable for details.
Definition: Module.h:84

## ◆ setRxBandwidth()

int16_t Si443x::setRxBandwidth | ( | float | rxBw | ) |

Sets receiver bandwidth. Allowed values range from 2.6 to 620.7 kHz.

Parameters

  rxBw | Receiver bandwidth to be set in kHz.

Returns
  Status Codes

Todo:
  float tolerance equality as macro?

## ◆ setSyncWord()

int16_t Si443x::setSyncWord | ( | uint8_t * | syncWord,
|  | size_t | len
| ) |  |
| virtual

Sets sync word. Up to 4 bytes can be set as sync word.

Parameters

  syncWord | Pointer to the array of sync word bytes.
  len | Sync word length in bytes.

Reimplemented from PhysicalLayer.

## ◆ sleep()

int16_t Si443x::sleep | ( |  | ) |
| virtual

Sets the module to sleep to save power. Module will not be able to transmit or receive any data while in sleep mode. Module will wake up automatically when methods like transmit or receive are called.

Returns
  Status Codes

Reimplemented from PhysicalLayer.

## ◆ standby() [1/2]

int16_t Si443x::standby | ( |  | ) |
| override virtual

Sets the module to standby (with XTAL on).

Returns
  Status Codes

Reimplemented from PhysicalLayer.

## ◆ standby() [2/2]

int16_t Si443x::standby | ( | uint8_t | mode | ) |
| override virtual

Sets the module to standby.

Parameters

  mode | Standby mode to be used.

Returns
  Status Codes

Reimplemented from PhysicalLayer.

## ◆ startReceive() [1/2]

int16_t Si443x::startReceive | ( |  | ) |
| virtual

Interrupt-driven receive method. IRQ will be activated when full valid packet is received.

Returns
  Status Codes

Reimplemented from PhysicalLayer.

## ◆ startReceive() [2/2]

int16_t Si443x::startReceive | ( | uint32_t | timeout,
|  | uint16_t | irqFlags,
|  | uint16_t | irqMask,
|  | size_t | len
| ) |  |
| virtual

Interrupt-driven receive method, implemented for compatibility with PhysicalLayer.

Parameters

  timeout | Ignored.
  irqFlags | Ignored.
  irqMask | Ignored.
  len | Ignored.

Returns
  Status Codes

Reimplemented from PhysicalLayer.

## ◆ startTransmit() [1/3]

int16_t PhysicalLayer::startTransmit

Interrupt-driven Arduino String transmit method. Unlike the standard transmit method, this one is non-blocking. Interrupt pin will be activated when transmission finishes.

Parameters

  str | C-string that will be transmitted.
  addr | Node address to transmit the packet to. Only used in FSK mode.

Returns
  Status Codes

## ◆ startTransmit() [2/3]

int16_t PhysicalLayer::startTransmit

Interrupt-driven binary transmit method.

Parameters

  data | Binary data that will be transmitted.
  len | Length of binary data to transmit (in bytes).
  addr | Node address to transmit the packet to. Only used in FSK mode.

Returns
  Status Codes

## ◆ startTransmit() [3/3]

int16_t Si443x::startTransmit | ( | uint8_t * | data,
|  | size_t | len,
|  | uint8_t | addr = `0`
| ) |  |
| override virtual

Interrupt-driven binary transmit method. Will start transmitting arbitrary binary data up to 64 bytes long.

Parameters

  data | Binary data that will be transmitted.
  len | Length of binary data to transmit (in bytes).
  addr | Node address to transmit the packet to.

Returns
  Status Codes

Todo:
  use header as address field?

Reimplemented from PhysicalLayer.

## ◆ transmit() [1/3]

int16_t PhysicalLayer::transmit

C-string transmit method.

Parameters

  str | C-string that will be transmitted.
  addr | Node address to transmit the packet to. Only used in FSK mode.

Returns
  Status Codes

## ◆ transmit() [2/3]

int16_t PhysicalLayer::transmit

Binary transmit method. Must be implemented in module class.

Parameters

  data | Binary data that will be transmitted.
  len | Length of binary data to transmit (in bytes).
  addr | Node address to transmit the packet to. Only used in FSK mode.

Returns
  Status Codes

## ◆ transmit() [3/3]

int16_t Si443x::transmit | ( | uint8_t * | data,
|  | size_t | len,
|  | uint8_t | addr = `0`
| ) |  |
| override virtual

Binary transmit method. Will transmit arbitrary binary data up to 64 bytes long. For overloads to transmit Arduino String or C-string, see PhysicalLayer::transmit.

Parameters

  data | Binary data that will be transmitted.
  len | Length of binary data to transmit (in bytes).
  addr | Node address to transmit the packet to.

Returns
  Status Codes

Reimplemented from PhysicalLayer.

## ◆ transmitDirect()

int16_t Si443x::transmitDirect | ( | uint32_t | frf = `0` | ) |
| override virtual

Enables direct transmission mode. While in direct mode, the module will not be able to transmit or receive packets.

Parameters

  frf | 24-bit raw frequency value to start transmitting at. Required for quick frequency shifts in RTTY.

Returns
  Status Codes

Todo:
  integers only

Reimplemented from PhysicalLayer.

## ◆ variablePacketLengthMode()

int16_t Si443x::variablePacketLengthMode | ( | uint8_t | maxLen = `RADIOLIB_SI443X_MAX_PACKET_LENGTH` | ) |

Set modem in variable packet length mode.

Parameters

  maxLen | Maximum packet length.

Returns
  Status Codes

The documentation for this class was generated from the following files:

- src/modules/Si443x/Si443x.h
- src/modules/Si443x/Si443x.cpp